// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import static net.cellcomputing.himawari.library.EqModeBlock.*;

/**
 * 
 * Define the context that exists between calls to RiBegin/RiEnd.
 * RiBegin / RiEnd ̌ĂяoĂԂɑ݂AReLXg`B
 * 
 * @author NTT DATA Corporation
 */
public strictfp class CqMainModeBlock extends CqModeBlock
{
	
	/**
	 * RXgN^B@l̐ݒB
	 * @param	pconParent	Ocontext
	 */
	public CqMainModeBlock( final CqModeBlock pconParent )
	{
		// Create new Attributes as they must be pushed/popped by the state change.
		//@Ԃ̕ωŕςAgr[gV쐬B
		super( pconParent, BeginEnd );
		m_pattrCurrent = new CqAttributes();
		m_pattrCurrent.AddRef();
		m_ptransCurrent =  new CqTransform();
	}

	/**
	 *  fXgN^B<br>
	 *	QƂ̍폜B@(QƃJE^fNgB) 
	 * @see net.cellcomputing.himawari.library.CqModeBlock#destruct()
	 */
	public void destruct()
	{
		m_pattrCurrent.Release();
	}


	/** 
	 * Create a main context.<br>
	 * C̃ReLXg쐬B
	 * 
	 * @warning ̃\bhC̃ReLXgĂ΂ꂽꍇAG[ƂȂB
	 */
	public CqModeBlock	BeginMainModeBlock()
	{
	   return ( null );
	}		

	/** 
	 * Delete the main context.<Br>
	 * 	C̃ReLXgB
	 * 
	 * @attention ̃\bĥ݁AC̃ReLXg邱ƂłB
	 */
	public void	EndMainModeBlock()
	{
		destruct();	
	}

	/** 
	 * Get a reference to the currently stored options.<br>
	 * 	ݕۑĂIvṼQb^B
	 * 
	 * @return	m_optCurrent	݂̃IvV
	 */
	public CqOptions optCurrent()
	{
		return ( m_optCurrent );
	}
	
	private CqOptions m_optCurrent = new CqOptions();	///< ݂̃OtBbNXIvVB	Current graphics environment options.
}
